import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSpecValue, ThinkSpecValueParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询商品规格值记录表
 */
export async function pageThinkSpecValue(params: ThinkSpecValueParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSpecValue>>>(
    THINK_API_URL + '/think/think-spec-value/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品规格值记录表列表
 */
export async function listThinkSpecValue(params?: ThinkSpecValueParam) {
  const res = await request.get<ApiResult<ThinkSpecValue[]>>(
    THINK_API_URL + '/think/think-spec-value',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品规格值记录表
 */
export async function addThinkSpecValue(data: ThinkSpecValue) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec-value',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品规格值记录表
 */
export async function updateThinkSpecValue(data: ThinkSpecValue) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec-value',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品规格值记录表
 */
export async function removeThinkSpecValue(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec-value/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品规格值记录表
 */
export async function removeBatchThinkSpecValue(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec-value/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品规格值记录表
 */
export async function getThinkSpecValue(id: number) {
  const res = await request.get<ApiResult<ThinkSpecValue>>(
    THINK_API_URL + '/think/think-spec-value/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
